unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  tPole = array [1..10] of Cardinal;
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  vstup: tPole = (1,2,3,1,2,4,1,3,3,5);
  cislo: Cardinal = 2;
  vystup: tPole;

implementation

{$R *.dfm}


function VsetkyVacsie(const a: tPole; hodnota: Cardinal; var vysledok: tPole): byte;
asm
//eax = a[1]^; edx = hodnota; ecx = vysledok[1]^
//kazdy prvok v a[] aj vysledok[] je typu Cardinal = 32-bit = cely register

  push ebx                  //pre istotu, mozno sa zidu :)
  push esi
  push edi
  push ebp

  mov edi,-1    //v edi bude pozicia v poli a(=eax) (znizena o 1) (a[1] => edi=0, ...)
  mov ebp,0     //v ebp bude pozicia v poli vysledok(=ecx) (znizena o 1) (ebp=0 => ukazujeme na vysledok[1]) (ebp bude zaroven pocitadlom prekopirovanych prvkov)

  @cyklus:     //prechadzanie vstupnym polom a(=eax)
  inc edi      //posunieme sa na dalsi prvok v poli (pred 1. behom cyklu je edi=-1 => zvysime na 0, ...)
  mov esi,[eax+edi*4]         //a[i] do esi (i=edi+1)
  cmp esi,edx                 //porovnaj a[i]?hodnota
  jbe @pokracuj               //a[i]<=hodnota => nekopiruj
  @kopiruj:                   //a[i]>hodnota => skopiruj a[i] do vysledok[j]
  mov [ecx+ebp*4],esi         //vysledok[j]:=a[i]
  inc ebp                     //posunieme sa vo vystupnom poli na dalsi volny prvok (Inc(j)) (zaroven zvysime pocet prekopirovanych)
  @pokracuj:
  cmp edi,10
  jb @cyklus   //opakuj 10-krat (cele vstupne pole)

  mov eax,ebp   //Result ma byt v eax; Result = pocet prekopirovanych prvkov = ebp

  pop ebp     //vratime, co sme na zaciatku odpamatali
  pop edi
  pop esi
  pop ebx
end;

procedure TForm1.Button1Click(Sender: TObject);
var i: integer;
 pocet: byte;
 s: string;
begin
  s:='(';
  for i:=1 to 10 do vystup[i]:=0;              //vynulujeme vystupne pole, nech sa tam nemiesaju blbosti
  pocet:=VsetkyVacsie(vstup,cislo,vystup);     //samotne volanie funkcie
  for i:=1 to pocet do begin                   //pripravenie vystupu
    s:=s+IntToStr(vystup[i])+',';
  end;
  for i:=pocet+1 to 9 do s:=s+'?,';
  s:=s+'?)';
  Edit2.Text:=IntToStr(pocet);                 //vypis
  Edit1.Text:=s;
end;

end.
